
package com.zipcodewilmington.productmanager;

import org.junit.Before;
import org.junit.Test;

import java.util.ArrayList;

import static junit.framework.TestCase.assertEquals;

public class InventoryTest {

    private Inventory inventory;
    private ArrayList<Product> list;
    private Product item1;
    private Product item2;

    @Before
    public void setUP(){
        list =  new ArrayList<Product>();
        item1 = new Product("Steak",15, 3.10, 1);
        item2 = new Product("Caviar",20, 4.99, 2);
        inventory = new Inventory(list);
    }


    @Test
    public void addProductTest() {
        //given
        inventory.addProduct(item1);
        int expected = 1;
        //when
        int actual = list.size();
        //then
        assertEquals(expected, actual);
    }

    @Test
    public void getTotalQuantityTest() {
        //given
        //create products in the test and assign them quantities then run method
        inventory.addProduct(item1);
        inventory.addProduct(item2);
        int expected = 35;
        //when
        int actual = inventory.getTotalQuantity();
        //then
        assertEquals(expected, actual);
    }

    @Test
    public void getSingleQuantityTest() {
        //given
        int expected = 15;
        //when
        int actual = inventory.getSingleQuantity(item1);
        //then
        assertEquals(expected, actual);
    }

    @Test
    public void minusProductQuantityTest() {
        //given
        inventory.addProduct(item1);
        inventory.addProduct(item2);

        int expected = 20;
        //when
        inventory.minusProduct(item1);
        int actual = inventory.getTotalQuantity();
        //then
        assertEquals(expected, actual);
    }

    @Test
    public void minusProductPriceTest(){
    //given
        inventory.addProduct(item1);
        inventory.addProduct(item2);
    inventory.minusProduct(item1);
    double expected = 4.99;
    //when
    double actual = inventory.getTotalPrice();
    //then
    assertEquals(expected, actual);
    }
}
